// coverage:ignore-file
// GENERATED CODE - DO NOT MODIFY BY HAND
// ignore_for_file: type=lint
// ignore_for_file: invalid_annotation_target
part of open_a_i_schema;

// ==========================================
// CLASS: ChatCompletionMessage
// ==========================================

/// A message in a chat conversation.
@freezed
class ChatCompletionMessage with _$ChatCompletionMessage {
  const ChatCompletionMessage._();

  /// Factory constructor for ChatCompletionMessage
  const factory ChatCompletionMessage({
    /// The role of the messages author. One of `system`, `user`, `assistant`, or `function`.
    required ChatCompletionMessageRole role,

    /// The contents of the message. `content` is required for all messages, and may be null for assistant messages with function calls.
    required String? content,

    /// The name and arguments of a function that should be called, as generated by the model.
    @JsonKey(name: 'function_call', includeIfNull: false)
    ChatCompletionMessageFunctionCall? functionCall,

    /// The name of the author of this message. `name` is required if role is `function`, and it should be the name of the function whose response is in the `content`. May contain a-z, A-Z, 0-9, and underscores, with a maximum length of 64 characters.
    @JsonKey(includeIfNull: false) String? name,
  }) = _ChatCompletionMessage;

  /// Object construction from a JSON representation
  factory ChatCompletionMessage.fromJson(Map<String, dynamic> json) =>
      _$ChatCompletionMessageFromJson(json);

  /// List of all property names of schema
  static const List<String> propertyNames = [
    'role',
    'content',
    'function_call',
    'name'
  ];

  /// Perform validations on the schema property values
  String? validateSchema() {
    return null;
  }

  /// Map representation of object (not serialized)
  Map<String, dynamic> toMap() {
    return {
      'role': role,
      'content': content,
      'function_call': functionCall,
      'name': name,
    };
  }
}
